.586
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include c:\masm32\include\windows.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\user32.inc
include c:\masm32\include\comctl32.inc

includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\comctl32.lib

.data

hInstance       DWORD           ?
CommandLine     LPSTR           ?

hMainWindow             dd              ?
MainWindowClass         db              'MainWindowClass',0
MainWindowName          db              'Rebar Window Example',0
MainWindowWidth         dd              600
MainWindowHeight        dd              250

RebarClass      db      'ReBarWindow32',0
ReBarName       db      'Rebar',0
hRebar          dd      ?
RebarWidth      dd      ?
RebarHeight     dd      ?

rect    RECT    <>
iccx    INITCOMMONCONTROLSEX    <>
rbbi    REBARBANDINFO	<>
rbi     REBARINFO       <>

hToolbar        dd      ?
ToolbarClass    db      'ToolbarWindow32',0
Buttons         TBBUTTON        <NULL,0101h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON        <NULL,0102h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON	  <NULL,0103h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
ComboBoxClass   db      'ComboBoxEx32',0
Combo           db      'ComboBox',0
Toolbar         db      'Toolbar',0

.code
        start:
                invoke  GetModuleHandle,NULL
                mov     hInstance,eax
                invoke  GetCommandLine
                mov     CommandLine,eax
;                invoke  InitCommonControls
                mov     iccx.dwSize,sizeof iccx
                mov     iccx.dwICC,ICC_COOL_CLASSES+ICC_USEREX_CLASSES+ICC_BAR_CLASSES
                invoke  InitCommonControlsEx,addr iccx
                invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
                invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

        local   wc:WNDCLASSEX
        local   msg:MSG

        mov     wc.cbSize,sizeof wc                                                             ;Tamanho da estrutura WNDCLASSEX
        mov     wc.style,CS_HREDRAW+CS_VREDRAW                                                  ;Estilos
        mov     wc.lpfnWndProc,offset WndProc                                                   ;Offset da rotina WndProc
        mov     wc.lpszMenuName,NULL                                                            ;Sem menu predefinido
        mov     wc.lpszClassName,offset MainWindowClass                                         ;Pointer do nome da classe da janela
        mov     wc.cbClsExtra,NULL                                                              
        mov     wc.cbWndExtra,NULL                                                              
        mov     wc.hbrBackground,COLOR_WINDOW                                                   ;Brush de background
        push    hInst
        pop     wc.hInstance                                                                    ;handle do modulo 
        invoke  LoadIcon,NULL,IDI_APPLICATION                                                   ;Carregar Icon
        mov     wc.hIcon,eax                                                                    ;Adicionar Icon  estrutura
        mov     wc.hIconSm,eax                                                                  ;adicionar Icon pequeno  estrutura
        invoke  LoadCursor,NULL,IDC_ARROW                                                       ;Carregar cursor
        mov     wc.hCursor,eax                                                                  ;adicionar Cursor  estrutura
        invoke  RegisterClassEx,addr wc                                                         ;Registar a classe        
        invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW+\   ;Criar a janela
                WS_CLIPCHILDREN+WS_CLIPSIBLINGS,\
                NULL,NULL,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
        mov     hMainWindow,eax                                                                 ;Salvar o handle da janela prinicipal
        invoke  ShowWindow,eax,SW_SHOWNORMAL                                                    ;Mostrar janela
        invoke  UpdateWindow,hMainWindow                                                        ;Refrescar janela

        .while  TRUE                                                                            ;Processar mensagens 
                                                                                                ;enquanto eax!=0
                invoke  GetMessage,addr msg,NULL,0,0

        .break .if (!eax)

                invoke  TranslateMessage,addr msg
                invoke  DispatchMessage,addr msg

        .endw

        mov     eax,msg.wParam
        ret     

WinMain endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        .if     uMsg==WM_DESTROY

                invoke  PostQuitMessage,NULL            

        .elseif uMsg==WM_CREATE
                
                mov     edi,lParam
                assume  edi:PTR CREATESTRUCT
 
               .if     [edi].hWndParent==NULL

                        invoke  CreateWindowEx,WS_EX_TOOLWINDOW,addr RebarClass,NULL,WS_VISIBLE+WS_CHILD+\
                                WS_CLIPCHILDREN+WS_CLIPSIBLINGS+RBS_AUTOSIZE+CCS_NODIVIDER,\
                                0,0,40,220,hWnd,10h,hInstance,NULL
                        mov     hRebar,eax

                        mov     rbbi.cbSize,sizeof rbbi
                        mov     rbbi.fMask,RBBIM_STYLE+RBBIM_CHILD+RBBIM_CHILDSIZE+RBBIM_SIZE+RBBIM_TEXT
                        mov     rbbi.fStyle,RBBS_GRIPPERALWAYS+RBBS_TOPALIGN
                        invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,\
                                WS_VISIBLE+WS_CHILD+CCS_NOPARENTALIGN+CCS_NORESIZE,\
                                0,50,32,200,hWnd,0100h,hInstance,NULL
                        mov     hToolbar,eax
                        push    eax
                        invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
                        invoke  SendMessage,hToolbar,TB_ADDBUTTONS,3,addr Buttons
                        invoke  SendMessage,hToolbar,TB_SETBUTTONSIZE,NULL,1a001ah
                        invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL

                        pop     eax
                        mov     rbbi.hwndChild,eax
                        mov     rbbi.cxMinChild,78
                        mov     rbbi.cyMinChild,30
                        mov     rbbi.lx,100
                        mov     rbbi.lpText,offset Toolbar
                        mov     rbbi.cch,sizeof Toolbar

                        invoke  SendMessage,hRebar,RB_INSERTBAND,0,addr rbbi
                        invoke  CreateWindowEx,NULL,addr ComboBoxClass,NULL,WS_VISIBLE+WS_CHILD+CBS_HASSTRINGS+CBS_DROPDOWNLIST+CCS_NOPARENTALIGN,\
                                        0,2,0,1ah,hWnd,0200h,hInstance,NULL
                        mov     rbbi.hwndChild,eax
                        mov     rbbi.cyMinChild,28
                        mov     rbbi.cxMinChild,100
                        mov     rbbi.lx,550
                        mov     rbbi.lpText,offset Combo
                        invoke  SendMessage,hRebar,RB_INSERTBAND,1,addr rbbi

                .endif

        .else

                invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
                ret

        .endif

        xor     eax,eax
        ret

WndProc endp

end     start                                       